
(function($) {
	//重直水平居中
	$.fn.center = function() {
		return this.each(function() {
			var $this = $(this),
				parent = $this.parent(),
				topPos,
				topMargin,
				leftMargin,
				resizeTimeout;
			if (parent.is("body:not(.root-height-set)")) {
				$("html,body").css("height", "100%").addClass("root-height-set");
			}
			if ($this.css("position") === "absolute" || $this.css("position") === "fixed") {
				topPos = "50%";
				topMargin = "-" + Math.round($this.outerHeight() / 2) + "px";
				leftMargin = "-" + Math.round($this.outerWidth() / 2) + "px";
				$this.css({
					"left": "50%",
					"margin-left": leftMargin
				});
			} else {
				topPos = Math.floor((parent.height() - $this.outerHeight()) / 2);
				if(topPos<0) topPos=0;
				topMargin = "auto";
				$this.css({
					"position": "relative",
					"margin-left": "auto",
					"margin-right": "auto"
				});
			}
			$this.css({
				"top": topPos,
				"margin-top": topMargin
			});
			$(window).resize(function() {
				if (resizeTimeout) {
					clearTimeout(resizeTimeout);
				}
				resizeTimeout = setTimeout(function() {
					if ($this.css("position") === "absolute") {
						topMargin = "-" + Math.round($this.outerHeight() / 2) + "px";
						leftMargin = "-" + Math.round($this.outerWidth() / 2) + "px";
						$this.css({
							"margin-left": leftMargin,
							"margin-top": topMargin
						});
					} else {
						topPos = Math.floor((parent.height() - $this.outerHeight()) / 2);
						if(topPos<0) topPos=0;
						$this.css("top", topPos);
					}
				}, 50);
			});
		});
	};
	//垂直居中	
    $.fn.vAlign = function () {
        return this.each(function (i) {
            var h = $(this).height();
            var oh = $(this).outerHeight();
            var mt = (h + (oh - h)) / 2;
            $(this).css("margin-top", "-" + mt + "px");
            $(this).css("top", "50%");
            $(this).css("position", "absolute");
        });
    };	
	//水平居中
	$.fn.hAlign = function() {
		return this.each(function(i){
		var w = $(this).width();
		var ow = $(this).outerWidth();	
		var ml = (w + (ow - w)) / 2;	
		$(this).css("margin-left", "-" + ml + "px");
		$(this).css("left", "50%");
		$(this).css("position", "absolute");
		});
	};  
	
})(jQuery);

function Center(id){			    
	var W = $("#"+id).css("width").replace("px", ""); 	//css("width")这样获取的是 数字加px,
    var H = $("#"+id).css("height").replace("px", ""); 	//css("height")这样获取的是 数字加px
    $("#"+id).css({
        "margin-left": ($(document).width() - W) / 2,
        "margin-top":  ($(document).height()- H) / 2
    });	 
}

/*
* 频率控制 返回函数连续调用时，fn 执行频率限定为每多少时间执行一次
* @param fn {function}  需要调用的函数
* @param delay  {number}    延迟时间，单位毫秒
* @param immediate  {bool} 给 immediate参数传递false 绑定的函数先执行，而不是delay后后执行。
* @return {function}实际调用函数
*/
var throttle = function (fn,delay, immediate, debounce) {
   var curr = +new Date(),//当前事件
       last_call = 0,
       last_exec = 0,
       timer = null,
       diff, //时间差
       context,//上下文
       args,
       exec = function () {
           last_exec = curr;
           fn.apply(context, args);
       };
   return function () {
       curr= +new Date();
       context = this,
       args = arguments,
       diff = curr - (debounce ? last_call : last_exec) - delay;
       clearTimeout(timer);
       if (debounce) {
           if (immediate) {
               timer = setTimeout(exec, delay);
           } else if (diff >= 0) {
               exec();
           }
       } else {
           if (diff >= 0) {
               exec();
           } else if (immediate) {
               timer = setTimeout(exec, -diff);
           }
       }
       last_call = curr;
   }
};
 
/*
* 空闲控制 返回函数连续调用时，空闲时间必须大于或等于 delay，fn 才会执行
* @param fn {function}  要调用的函数
* @param delay   {number}    空闲时间
* @param immediate  {bool} 给 immediate参数传递false 绑定的函数先执行，而不是delay后后执行。
* @return {function}实际调用函数
*/
 
var debounce = function (fn, delay, immediate) {
   return throttle(fn, delay, immediate, true);
};

//将一对象(包括数组、JSON、function)转换成字符串
function obj2str(o){
	var r = [];
	if (typeof o === "string")
		return "\"" + o.replace(/([\'\"\\])/g, "\\$1").replace(/(\n)/g, "\\n").replace(/(\r)/g, "\\r").replace(/(\t)/g, "\\t") + "\"";
	if (typeof o === "object") {
		if (!o.sort) {
			for (var i in o)
				r.push("\"" + i + "\":" + obj2str(o[i]));
			if (!!document.all && !/^\n?function\s*toString\(\)\s*\{\n?\s*\[native code\]\n?\s*\}\n?\s*$/.test(o.toString)) {
				r.push("toString:" + o.toString.toString());
			}
			r = "{" + r.join() + "}";
		} else {
			for (var i = 0; i < o.length; i++)
				r.push(obj2str(o[i]));
			r = "[" + r.join() + "]";
		}
		return r;
	}
	return o.toString(); 
}

$.extend($.fn.validatebox.defaults.rules, {
    loginName: {
        validator : function(value) { 
            return /^[a-zA-Z][a-zA-Z0-9_]{4,15}$/i.test(value); 
        }, 
        message : '用户名格式（字母开头，允许5-16字节，允许字母数字下划线）' 
    },
    safepass: {
        validator : function(value) { 
            return /^[a-zA-Z][a-zA-Z0-9_]{4,15}$/i.test(value); 
        },
        message: '密码格式（字母开头，允许5-16字节，允许字母数字下划线）' 
    }, 
    model: {
        validator : function(value) { 
            return /^[^\u4e00-\u9fa5]{1,17}$/i.test(value); 
        },
        message: '型号格式（允许5-30字节，非中文字符）' 
    }, 
    equalTo: {
        validator: function (value, param) {
            return value == $(param[0]).val();
        },
        message: '两次输入的字符不一至'
    },
	mobile: {// 验证手机
		validator: function (value, param) {	
			return (/^1\d{10}$/g.test(value));
		},
		message: '手机号码不正确'
	},
	ip: {// 验证IP地址
		validator:function(value) {
			var exp=/^(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])$/;
			if(value.match(exp)==null){
				return false;
			}else{
				return true;
			}
		},
		message:'IP地址格式不正确'
	},
	textlen: {
        validator : function(value) { 
            return /^[0-9a-zA-Z\u4e00-\u9fa5]{1,16}$/i.test(value); 
        }, 
        message : '抱歉，只允许1-16个字符' 
    },
	number: {
        validator: function (value, param) {
            return /^\d+$/.test(value);
        },
        message: '请输入数字'
    },
	limitvalue: {
        validator: function (value, param) {
            return /^[-+]?\d+(\.\d+)?$/.test(value);
        },
        message: '请输入数字.'
    },    
	validdate: {
        validator: function (value, param) {
			var now = new Date().getTime();
			return ((value * 1000) > now);
        },
        message: '请选择未来的日期！'
    }	
});

//写cookies ,时间单位毫秒
function setCookie(name,value,time,auth) 
{ 
	if(auth==true){
		value = Base64.encode(value);
	}
	if(time>0){
	    var exp = new Date(); 
	    exp.setTime(exp.getTime() + time); 
	    document.cookie = name + "="+ escape (value) + ";path=/;expires=" + exp.toGMTString(); 		
	}
	else{
		document.cookie = name + "="+ escape (value)+ ";path=/";
	}
} 

//读取cookies 
function getCookie(name,auth) 
{ 
    var arr,reg=new RegExp("(^| )"+name+"=([^;]*)(;|$)");
    if(arr=document.cookie.match(reg)){
    	var value = unescape(arr[2]);  	
    	if(auth==true){
    		return Base64.decode(value);
    	}
        return value;
    }
    return null;  
} 

$.extend($.fn.datagrid.defaults.editors, {
	pwd: {
		init: function(container, options) {	
			var input = $('<input class="datagrid-editable-input" type="password"/>').appendTo(container);
			return input;
		},
		getValue: function(target) {
			return $(target).val();
		},
		setValue: function(target, value) {
			$(target).val(value);
		},
		resize: function(target, width) {
			var input = $(target);
			if($.boxModel == true) {
				input.width(width - (input.outerWidth() - input.width()));
			} else {
				input.width(width);
			}
		}
	}
});

//Base64加密解密
var Base64 = {

	// private property
	_keyStr:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",

	// public method for encoding
	encode:function (input) {
		var output = "";
		var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
		var i = 0;

		input = Base64._utf8_encode(input);

		while (i < input.length) {

			chr1 = input.charCodeAt(i++);
			chr2 = input.charCodeAt(i++);
			chr3 = input.charCodeAt(i++);

			enc1 = chr1 >> 2;
			enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
			enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
			enc4 = chr3 & 63;

			if (isNaN(chr2)) {
				enc3 = enc4 = 64;
			} else if (isNaN(chr3)) {
				enc4 = 64;
			}

			output = output + this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) + this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);

		}

		return output;
	},

	// public method for decoding
	decode:function (input) {
		var output = "";
		var chr1, chr2, chr3;
		var enc1, enc2, enc3, enc4;
		var i = 0;

		input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

		while (i < input.length) {

			enc1 = this._keyStr.indexOf(input.charAt(i++));
			enc2 = this._keyStr.indexOf(input.charAt(i++));
			enc3 = this._keyStr.indexOf(input.charAt(i++));
			enc4 = this._keyStr.indexOf(input.charAt(i++));

			chr1 = (enc1 << 2) | (enc2 >> 4);
			chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
			chr3 = ((enc3 & 3) << 6) | enc4;

			output = output + String.fromCharCode(chr1);

			if (enc3 != 64) {
				output = output + String.fromCharCode(chr2);
			}
			if (enc4 != 64) {
				output = output + String.fromCharCode(chr3);
			}

		}

		output = Base64._utf8_decode(output);

		return output;

	},

	// private method for UTF-8 encoding
	_utf8_encode:function (string) {
		string = string.replace(/\r\n/g, "\n");
		var utftext = "";

		for (var n = 0; n < string.length; n++) {

			var c = string.charCodeAt(n);

			if (c < 128) {
				utftext += String.fromCharCode(c);
			} else if ((c > 127) && (c < 2048)) {
				utftext += String.fromCharCode((c >> 6) | 192);
				utftext += String.fromCharCode((c & 63) | 128);
			} else {
				utftext += String.fromCharCode((c >> 12) | 224);
				utftext += String.fromCharCode(((c >> 6) & 63) | 128);
				utftext += String.fromCharCode((c & 63) | 128);
			}

		}

		return utftext;
	},

	// private method for UTF-8 decoding
	_utf8_decode:function (utftext) {
		var string = "";
		var i = 0;
		var c = c1 = c2 = 0;

		while (i < utftext.length) {

			c = utftext.charCodeAt(i);

			if (c < 128) {
				string += String.fromCharCode(c);
				i++;
			} else if ((c > 191) && (c < 224)) {
				c2 = utftext.charCodeAt(i + 1);
				string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
				i += 2;
			} else {
				c2 = utftext.charCodeAt(i + 1);
				c3 = utftext.charCodeAt(i + 2);
				string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
				i += 3;
			}

		}

		return string;
	}
}


